using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Soap;


namespace SmileProxy
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class FormMain : System.Windows.Forms.Form
	{
		private System.Drawing.Icon		_NotifyIconStart	= null;
		private System.Drawing.Icon		_NotifyIconStop		= null;
		private bool					_SystemShutdown		= false;
		private SystemConfig			_SystemConfig		= null;
		private string					_SystemConfigFile	= "SmileProxyConfig.xml";
		private Listener				_Listener			= null;

		private System.Windows.Forms.NotifyIcon notifyIcon1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
		private SmileProxy.NumericTextBox TextPort;
		private System.Windows.Forms.ContextMenu menuNotify;
		private System.Windows.Forms.MenuItem menuStatus;
		private System.Windows.Forms.MenuItem menuExit;
		private System.ComponentModel.IContainer components;

		enum WindowsMessage : int {
			QueryEndSession = 0x0011,
			EndSession      = 0x0016
		}

		protected override void WndProc(ref Message m) {
			if (m.Msg == (int)WindowsMessage.QueryEndSession ||
				m.Msg == (int)WindowsMessage.EndSession) {
				_SystemShutdown = true;
			}
			base.WndProc (ref m);
		}

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() {
			System.Threading.Mutex m = new System.Threading.Mutex(false, "SmileProxy");
			if (m.WaitOne(0, false) == true) {
				Application.Run(new FormMain());
			}
			System.GC.KeepAlive(m);
		}

		public FormMain()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//

			_SystemConfig = new SystemConfig();
			this.SystemConfigDeserialize();

			this.TextPort.Text = _SystemConfig.Port.ToString();

			System.Reflection.Assembly asm = null;
			try {
				asm = System.Reflection.Assembly.GetExecutingAssembly();
				_NotifyIconStart = new Icon(asm.GetManifestResourceStream("SmileProxy.Icon1.ico"));
				_NotifyIconStop  = new Icon(asm.GetManifestResourceStream("SmileProxy.Icon2.ico"));
			}
			finally {
				asm = null;
			}

			try {
				if (_SystemConfig.AutoStart) {
					this.ListenerStart();
				} else {
					this.ListenerStop();
				}
			}
			catch {
				this.ListenerStop();
			}
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormMain));
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label1 = new System.Windows.Forms.Label();
			this.notifyIcon1 = new System.Windows.Forms.NotifyIcon(this.components);
			this.TextPort = new SmileProxy.NumericTextBox();
			this.menuNotify = new System.Windows.Forms.ContextMenu();
			this.menuStatus = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox1
			// 
			this.groupBox1.BackColor = System.Drawing.Color.MintCream;
			this.groupBox1.Controls.Add(this.TextPort);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Location = new System.Drawing.Point(24, 24);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(296, 64);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "Lisning Port";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// notifyIcon1
			// 
			this.notifyIcon1.ContextMenu = this.menuNotify;
			this.notifyIcon1.Icon = ((System.Drawing.Icon)(resources.GetObject("notifyIcon1.Icon")));
			this.notifyIcon1.Text = "SmileProxy";
			this.notifyIcon1.Visible = true;
			this.notifyIcon1.DoubleClick += new System.EventHandler(this.notifyIcon1_DoubleClick);
			// 
			// TextPort
			// 
			this.TextPort.Location = new System.Drawing.Point(96, 24);
			this.TextPort.Name = "TextPort";
			this.TextPort.Size = new System.Drawing.Size(56, 19);
			this.TextPort.TabIndex = 1;
			this.TextPort.Text = "9999";
			this.TextPort.TextChanged += new System.EventHandler(this.TextPort_TextChanged);
			// 
			// menuNotify
			// 
			this.menuNotify.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuStatus,
																					   this.menuExit});
			// 
			// menuStatus
			// 
			this.menuStatus.Index = 0;
			this.menuStatus.Text = "Jn";
			this.menuStatus.Click += new System.EventHandler(this.menuStatus_Click);
			// 
			// menuExit
			// 
			this.menuExit.Index = 1;
			this.menuExit.Text = "I";
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.BackColor = System.Drawing.Color.MidnightBlue;
			this.ClientSize = new System.Drawing.Size(338, 111);
			this.Controls.Add(this.groupBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "FormMain";
			this.Text = "SmileProxy";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.FormMain_Closing);
			this.SizeChanged += new System.EventHandler(this.FormMain_SizeChanged);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void FormMain_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
			if (_SystemShutdown) {
				this.notifyIcon1.Visible = false;
				this.notifyIcon1.Dispose();
				return;
			}
			e.Cancel = true;
			this.Visible = false;
		}

		private void FormMain_SizeChanged(object sender, System.EventArgs e) {
			if (this.Visible == true && this.WindowState == FormWindowState.Minimized) {
				this.Visible = false;
			}
		}

		public void SystemConfigSerialize() {
			SoapFormatter formatter = new SoapFormatter();

			using( Stream stream = new FileStream(_SystemConfigFile, FileMode.Create) ) {
				formatter.Serialize(stream, _SystemConfig);
			}
		}

		public void SystemConfigDeserialize() {
			SoapFormatter formatter = new SoapFormatter();

			if (!System.IO.File.Exists(_SystemConfigFile)) {
				if (_SystemConfig == null) {
					_SystemConfig = new SystemConfig();
				}
				return;
			}

			using( Stream stream = new FileStream(_SystemConfigFile, FileMode.Open) ) {
				_SystemConfig = (SystemConfig) formatter.Deserialize(stream);
			}
		}

		private void notifyIcon1_DoubleClick(object sender, System.EventArgs e) {
			this.Visible = true;
			if (this.WindowState == FormWindowState.Minimized) {
				this.WindowState = FormWindowState.Normal;
			}
			this.Activate();
		}

		private void menuExit_Click(object sender, System.EventArgs e) {
			this.Exit();
		}

		private void Exit() {
			this.ListenerStop();
			this.SystemConfigSerialize();
			Application.Exit();
		}

		private void menuStatus_Click(object sender, System.EventArgs e) {
			if (_Listener == null) {
				this.ListenerStart();
			} else {
				this.ListenerStop();
			}
		}

		private void ListenerStart() {
			this.ListenerStop();

			_Listener = new Listener( _SystemConfig.Port );
			_Listener.Start();
			this.menuStatus.Text = "~";
			this.notifyIcon1.Icon = _NotifyIconStart;
		}

		private void ListenerStop() {
			if (_Listener != null) {
				if (_Listener.IsStarted) {
					_Listener.Stop();
				}
				_Listener = null;
			}
			this.menuStatus.Text = "Jn";
			this.notifyIcon1.Icon = _NotifyIconStop;
		}

		private void TextPort_TextChanged(object sender, System.EventArgs e) {
			int port;

			if (TextPort.Text == "") {
				return;
			}
			port = int.Parse(TextPort.Text);
			if (port <= 1024 || 65536 < port) {
				return;
			}

			_SystemConfig.Port = port;
		}


	}
}
