using System;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

namespace SmileProxy
{

	public class HttpCache {

		private string _CacheDir	= "smilevideo";
		private string _Uri			= "";
		private string _Id			= "";
		private Stream _InStream	= null;

		public HttpCache() {
		}

		public HttpCache(string uri) {
			this.Uri = uri;
		}

		public HttpCache(string uri, Stream inStream) {
			this.Uri = uri;
			this._InStream = inStream;
		}

		public string Uri {
			get {
				return _Uri;
			}
			set {
				Regex r = new Regex("http://[^/]+(?:smilevideo|nicovideo)\\.jp/smile\\?v=([^.]+)\\.\\d+(low)?");
				Match m = r.Match(value);
				if (!m.Success) {
					_Uri = "";
					_Id  = "";
				}
				else {
					_Uri = value;
					_Id  = m.Groups[1].Value;
				}
			}
		}

		public string Path {
			get {
				if (_Id == "") {
					return "";
				}
				return _CacheDir + "/" + "sm" + _Id;
			}
		}

		public bool Exists() {
			return System.IO.File.Exists(this.Path);
		}

		public long Length {
			get {
				System.IO.FileInfo fi = new FileInfo(this.Path);
				return fi.Length;
			}
		}

		public Stream GetStream() {
			return _InStream;
		}

	}
}
