using System;
using System.Collections;

namespace SmileProxy {
	/// <summary>
	/// HttpHeaderItemCollection ̊Tv̐łB
	/// </summary>
	public class HttpHeaderItemCollection : System.Collections.CollectionBase {
		public HttpHeaderItemCollection() : base() {
		}

		public HttpHeaderItem this[int index] {
			get {
				return (HttpHeaderItem)((IList)this)[index];
			}
			set {
				((IList)this)[index] = value; 
			}
		}

		public HttpHeaderItem this[string name] {
			get {
				int index = this.IndexOf(name);
				if (index < 0) {
					return null;
				}
				return (HttpHeaderItem)((IList)this)[index];
			}
			set {
				int index = this.IndexOf(name);
				if (index < 0) {
					if (value == null) {
						return;
					}
					Add(value);
				}
				else {
					if (value == null) {
						((IList)this).RemoveAt(index);
					} else {
						((IList)this)[index] = value;
					}
				}
			}
		}

		public int Add(HttpHeaderItem value) {
			return ((IList)this).Add(value);
		}

		public bool Contains(HttpHeaderItem value) {
			return ((IList)this).Contains(value);
		}

		public int IndexOf(HttpHeaderItem value) {
			return ((IList)this).IndexOf(value);
		}

		public int IndexOf(string name) {
			int i;
			int len = this.Count;
			for (i=0;i<len;i++) {
				if (this[i].Name == name) {
					return i;
				}
			}
			return -1;
		}

		public void Insert(int index, HttpHeaderItem value) {
			((IList)this).Insert(index, value);
		}

		public void Remove(HttpHeaderItem value) {
			((IList)this).Remove(value);
		}


		protected override void OnValidate(object value) {
			// null `FbN
			if (value == null) { 
				throw new ArgumentNullException("value"); 
			}

			// ^`FbN
			if (!typeof(HttpHeaderItem).IsInstanceOfType(value)) {
				throw new ArgumentException("value  HttpHeaderItem ł͂܂B", "value");
			}
		}
	}
}
