using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace SmileProxy {

	public class NumericTextBox : System.Windows.Forms.TextBox {

		enum WindowsMessage : int {
			Paste = 0x0302
		}

		protected override void WndProc(ref Message m) {
			if (m.Msg == (int)WindowsMessage.Paste) {
				IDataObject iData = Clipboard.GetDataObject();
				if (iData.GetDataPresent(DataFormats.Text)) {
					string clipStr = (string)iData.GetData(DataFormats.Text);
					if (!System.Text.RegularExpressions.Regex.IsMatch(clipStr, @"^\d+$")) {
						return;
					}
				}
			}
			base.WndProc(ref m);
		}

		protected override void OnKeyPress(KeyPressEventArgs e) {
			if ((e.KeyChar < '0' || '9' < e.KeyChar) && e.KeyChar != '\b') {
				e.Handled = true;
			}
			base.OnKeyPress (e);
		}
	}
}
